// Fill out your copyright notice in the Description page of Project Settings.

#include "MyUserWidget.h"
#include <MyPlayerState.h>

bool UMyUserWidget::AllVerified() {
  UTextBlock * myVerifiers[9] = {
      URM_Verifier,
      MU_Verifier,
      Time_Verifier,
      GR_Verifier,
      CR_Verifier,
      ColX_Verifier,
      ColY_Verifier,
      WN_Verifier,
      AN_Verifier
  };
  for (auto & v : myVerifiers) {
    if (v->GetText().IsEmpty())
      return false;
  }
  return true;
}

void UMyUserWidget::NativeOnInitialized() {
  auto ps = StaticCast<AMyPlayerState *>(GetOwningPlayerState());
  if (ps == nullptr)
    return;
  opIdTextBlock->SetText(FText::FromString(ps->GetPlayerName()));
  UTextBlock * arcaneNumbers[9] = {
      URM_TextBlock,
      MU_TextBlock,
      Time_TextBlock,
      GR_TextBlock,
      CR_TextBlock,
      ColX_TextBlock,
      ColY_TextBlock,
      WN_TextBlock,
      AN_TextBlock
  };
  for (auto * n : arcaneNumbers) {
    auto x = FCString::Atod(*n->GetText().ToString());
    n->SetText(FText::FromString(FString::Printf(TEXT("%.7f"), x)));
  }
}
